=== src/wx/CMakeLists.txt ===
if(NOT TRANSLATIONS_ONLY AND NOT ENABLE_WX)
    return()
endif()

# Do not use this file directly.  Always use the top level CMakeLists.txt file
include(VbamFunctions)

set(VBAM_WX_COMMON
    audio/audio.cpp
    audio/audio.h
    audio/internal/openal.cpp
    audio/internal/openal.h
    background-input.cpp
    background-input.h
    cmdevents.cpp
    dialogs/accel-config.cpp
    dialogs/accel-config.h
    dialogs/base-dialog.cpp
    dialogs/base-dialog.h
    dialogs/directories-config.cpp
    dialogs/directories-config.h
    dialogs/display-config.cpp
    dialogs/display-config.h
    dialogs/game-boy-config.cpp
    dialogs/game-boy-config.h
    dialogs/game-maker.cpp
    dialogs/game-maker.h
    dialogs/gb-rom-info.cpp
    dialogs/gb-rom-info.h
    dialogs/joypad-config.cpp
    dialogs/joypad-config.h
    dialogs/sound-config.cpp
    dialogs/sound-config.h
    dialogs/speedup-config.cpp
    dialogs/speedup-config.h
    drawing.h
    extra-translations.cpp
    gfxviewers.cpp
    guiinit.cpp
    ioregs.h
    opts.cpp
    opts.h
    panel.cpp
    rpi.h
    sys.cpp
    viewers.cpp
    viewsupt.cpp
    viewsupt.h
    wayland.cpp
    wayland.h
    wxhead.h
    wxlogdebug.h
    wxvbam.cpp
    wxvbam.h
    x11keymap.h
    xrc/visualboyadvance-m.xpm
    # Generated files.
    ${VBAM_GENERATED_DIR}/wx/builtin-xrc.h
    ${VBAM_GENERATED_DIR}/wx/builtin-over.h
    ${VBAM_GENERATED_DIR}/wx/cmdhandlers.h
    ${VBAM_GENERATED_DIR}/wx/cmd-evtable.h
)

if(NOT ZIP_PROGRAM)
    find_program(ZIP_PROGRAM zip DOC "zip compressor executable")
    if(WIN32 AND NOT ZIP_PROGRAM AND NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/zip.exe)
        if(NOT DEFINED POWERSHELL)
            message(FATAL_ERROR "Powershell is required for extraction.")
        endif()

        # Get zip binaries from wxrc.
        file(DOWNLOAD "https://www.willus.com/archive/zip64/infozip_binaries_win32.zip" ${CMAKE_CURRENT_BINARY_DIR}/infozip_binaries_win32.zip)

        # Unzip it.
        execute_process(
            COMMAND "${POWERSHELL}" -NoLogo -NoProfile -ExecutionPolicy Bypass -Command "& { Add-Type -A 'System.IO.Compression.FileSystem'; [IO.Compression.ZipFile]::ExtractToDirectory('${CMAKE_CURRENT_BINARY_DIR}/infozip_binaries_win32.zip', '${CMAKE_CURRENT_BINARY_DIR}'); }"
        )

        set(ZIP_PROGRAM ${CMAKE_CURRENT_BINARY_DIR}/zip.exe CACHE STRING "zip compressor executable" FORCE)
    endif()
    if(ZIP_PROGRAM)
        set(ZIP_PROGRAM "${ZIP_PROGRAM}" CACHE STRING "zip compressor executable" FORCE)
    else(NOT ZIP_PROGRAM)
        message(FATAL_ERROR "The zip compressor program is required for building.")
    endif()
endif()

if(MSVC)
    # Install gettext tools from nuget.

    # First fetch the nuget binary.
    if(NOT EXISTS ${CMAKE_BINARY_DIR}/nuget.exe)
        file(DOWNLOAD "https://dist.nuget.org/win-x86-commandline/latest/nuget.exe" ${CMAKE_BINARY_DIR}/nuget.exe)
    endif()

    # Add nuget package source.
    execute_process(
        COMMAND nuget sources add -Name "NuGet official package source" -Source "https://api.nuget.org/v3/index.json"
        OUTPUT_QUIET
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # Install the Gettext.Tools package.
    execute_process(
        COMMAND nuget.exe install Gettext.Tools -OutputDirectory ${CMAKE_BINARY_DIR}/nuget
        OUTPUT_QUIET
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # Find the path to the binaries in the package and add them to find path.
    file(GLOB pkg ${CMAKE_BINARY_DIR}/nuget/Gettext.Tools*)

    list(APPEND CMAKE_PROGRAM_PATH ${pkg}/tools/bin)
endif()

find_package(Gettext REQUIRED)
find_program(XGETTEXT xgettext)
find_program(MSGINIT  msginit)

if(NOT XGETTEXT OR NOT MSGINIT)
    message(SEND_ERROR "Cannot find gettext xgettext:'${XGETTEXT}' msginit:'${MSGINIT}'")
endif()

# Make the translations.zip
add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/translations.zip
    COMMAND ${CMAKE_COMMAND} -D "ZIP_PROGRAM=${ZIP_PROGRAM}" -P ${CMAKE_CURRENT_SOURCE_DIR}/make-translations-zip.cmake
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS translations make-translations-zip.cmake
)
add_custom_target(
    translations-zip
    ALL
    SOURCES ${CMAKE_BINARY_DIR}/translations.zip
)

if(TRANSLATIONS_ONLY)
    # Nothing more to do if we are only building the translations.zip file.
    return()
endif()

# wxWidgets configuration.
set(wxWidgets_USE_UNICODE ON)
if(CMAKE_BUILD_TYPE MATCHES "^(Debug|RelWithDebInfo)$")
    set(wxWidgets_USE_DEBUG ON) # noop if wx is compiled with --disable-debug, like in Mac Homebrew atm
endif()
if(VBAM_STATIC)
    set(wxWidgets_USE_STATIC ON)
endif()

unset(wx_find_extra)
if(CMAKE_TOOLCHAIN_FILE MATCHES "vcpkg")
  set(wx_find_extra NO_DEFAULT_PATH)
  set(wxWidgets_DIR "${VCPKG_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/share/wxwidgets")
endif()

set(ENABLE_OPENGL TRUE)
find_package(wxWidgets COMPONENTS xrc xml html adv net core base gl ${wx_find_extra})

if(NOT wxWidgets_FOUND)
    find_package(wxWidgets COMPONENTS xrc xml html adv net core base ${wx_find_extra} REQUIRED)
    set(ENABLE_OPENGL FALSE)
endif()

# Find OpenAL (required).
find_package(OpenAL REQUIRED)

# Workaround of static liblzma not being found on MSYS2.
if(VBAM_STATIC AND MSYS)
    unset(cleaned_up_wx_libs)
    foreach(lib ${wxWidgets_LIBRARIES})
        if(lib STREQUAL "-llzma")
            set(lib "liblzma.a")
        endif()

        list(APPEND cleaned_up_wx_libs "${lib}")
    endforeach()

    set(wxWidgets_LIBRARIES "${cleaned_up_wx_libs}")
endif()

list(APPEND CMAKE_REQUIRED_LIBRARIES ${wxWidgets_LIBRARIES})
list(APPEND CMAKE_REQUIRED_INCLUDES ${wxWidgets_INCLUDE_DIRS})
list(APPEND CMAKE_REQUIRED_FLAGS ${wxWidgets_CXX_FLAGS})
foreach(DEF ${wxWidgets_DEFINITIONS})
    list(APPEND CMAKE_REQUIRED_DEFINITIONS "-D${DEF}")
endforeach()

# Configure common settings for wx-based targets, like linking, include
# directories, compile options, and definitions.
function(configure_wx_target target)
    get_target_property(target_type ${target} TYPE)
    if(target_type STREQUAL "EXECUTABLE")
        set(target_is_executable TRUE)
    else()
        set(target_is_executable FALSE)
    endif()

    function(_add_link_libraries)
        if(${target_is_executable})
            target_link_libraries(${target} ${ARGN})
        else()
            target_link_libraries(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_include_directories)
        if(${target_is_executable})
            target_include_directories(${target} PRIVATE ${ARGN})
        else()
            target_include_directories(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_compile_options)
        if(${target_is_executable})
            target_compile_options(${target} PRIVATE ${ARGN})
        else()
            target_compile_options(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_compile_definitions)
        if(${target_is_executable})
            target_compile_definitions(${target} PRIVATE ${ARGN})
        else()
            target_compile_definitions(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    # Core emulator.
    _add_link_libraries(vbam-core)

    # Nonstd.
    _add_link_libraries(nonstd-lib)
    _add_include_directories(${NONSTD_INCLUDE_DIR})

    # wxWidgets.
    _add_link_libraries(${wxWidgets_LIBRARIES})
    _add_include_directories(${wxWidgets_INCLUDE_DIRS})
    _add_compile_options(${wxWidgets_CXX_FLAGS})
    _add_compile_definitions(${wxWidgets_DEFINITIONS})
    if(CMAKE_BUILD_TYPE MATCHES "^(Debug|RelWithDebInfo)$")
        _add_compile_definitions(${wxWidgets_DEFINITIONS_DEBUG})
    endif()

    # OpenAL.
    if(OPENAL_STATIC)
        _add_compile_definitions(AL_LIBTYPE_STATIC)
    endif()
    _add_include_directories(${OPENAL_INCLUDE_DIR})
    _add_link_libraries(${OPENAL_LIBRARY})

    # XAudio2.
    if(ENABLE_XAUDIO2)
        _add_compile_definitions(VBAM_ENABLE_XAUDIO2)
    endif()

    # FAudio.
    if(ENABLE_FAUDIO)
        _add_compile_definitions(VBAM_ENABLE_FAUDIO)
        if(MSVC)
            _add_link_libraries(FAudio::FAudio)
        else()
            _add_link_libraries(FAudio)
            if(WIN32)
                _add_link_libraries(dxguid uuid winmm ole32 advapi32 user32 mfplat mfreadwrite mfuuid propsys)
            endif()
        endif()
    endif()

    # Direct3D.
    if(NOT ENABLE_DIRECT3D)
        _add_compile_definitions(NO_D3D)
    endif()

    # SDL2.
    _add_link_libraries(${VBAM_SDL2_LIBS})

    # OpenGL.
    if(ENABLE_OPENGL)
        _add_link_libraries(${OPENGL_LIBRARIES})
    else()
        _add_compile_definitions(NO_OGL)
    endif()

endfunction()

# Sub-projects.
add_subdirectory(test)
add_subdirectory(config)
add_subdirectory(widgets)

set(VBAM_ICON visualboyadvance-m.icns)
set(VBAM_ICON_PATH ${CMAKE_CURRENT_SOURCE_DIR}/icons/${VBAM_ICON})

add_executable(
    visualboyadvance-m
    WIN32
    MACOSX_BUNDLE
)

target_sources(visualboyadvance-m PRIVATE ${VBAM_WX_COMMON} ${VBAM_ICON_PATH})
target_include_directories(visualboyadvance-m PRIVATE ${SDL2_INCLUDE_DIRS})

target_link_libraries(
    visualboyadvance-m
    vbam-components-draw-text
    vbam-components-filters
    vbam-components-filters-agb
    vbam-components-filters-interframe
    vbam-components-user-config
    vbam-wx-config
    vbam-wx-widgets
)

# adjust link command when making a static binary for gcc
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND VBAM_STATIC)
    if(MSYS)
        add_custom_command(
            TARGET visualboyadvance-m PRE_LINK
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/msys-link-static.cmake
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    else()
        add_custom_command(
            TARGET visualboyadvance-m PRE_LINK
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/link-static.cmake
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    endif()
endif()

add_dependencies(visualboyadvance-m translations-zip)

# on unix we have to check for X11 before we overwrite all the compile/link
# flags with the wx tests
if(NOT WIN32 AND NOT APPLE)
    find_package(X11)

    if(X11_X11_LIB)
        target_include_directories(visualboyadvance-m PRIVATE ${X11_INCLUDE_DIR})
        target_link_libraries(visualboyadvance-m ${X11_X11_LIB})
        target_compile_definitions(visualboyadvance-m PRIVATE HAVE_X11)
        if(X11_Xscreensaver_LIB)
        target_link_libraries(visualboyadvance-m ${X11_Xscreensaver_LIB})
            target_compile_definitions(visualboyadvance-m PRIVATE HAVE_XSS)
        endif()
    endif()

    find_library(EGL_LIBRARY EGL)

    if(EGL_LIBRARY)
    target_link_libraries(visualboyadvance-m ${EGL_LIBRARY})
        target_compile_definitions(visualboyadvance-m PRIVATE HAVE_EGL)
    endif()

    find_library(WAYLAND_LIBRARY wayland-client)
    if(WAYLAND_LIBRARY)
        target_link_libraries(visualboyadvance-m ${WAYLAND_LIBRARY})
    endif()
endif()

if(WIN32)
    target_sources(visualboyadvance-m
        PRIVATE
        audio/internal/dsound.cpp
        wxvbam.rc
    )
    target_link_libraries(visualboyadvance-m
        dxguid dsound wsock32 ws2_32 imm32 version winmm)

    # Force a re-link when the manifest file is modified.
    set_target_properties(visualboyadvance-m
        PROPERTIES
        LINK_DEPENDS
        "${CMAKE_CURRENT_LIST_DIR}/visualboyadvance-m.manifest")

    if(MSVC)
        # Disable the auto-generated manifest from CMake.
        target_link_options(visualboyadvance-m PRIVATE "/MANIFEST:NO")
    endif()

    # wxWidgets fails to bring in its dependency.
    find_library(PCRE_LIB pcre2-16 REQUIRED)
    target_link_libraries(visualboyadvance-m ${PCRE_LIB})
endif()

if(APPLE)
    target_sources(visualboyadvance-m PRIVATE
        macsupport.mm
    )
endif()

# link libgcc/libstdc++ statically on mingw
# and adjust link command when making a static binary
if(CMAKE_COMPILER_IS_GNUCXX AND VBAM_STATIC)
